-- Created by Giseldah

-- Floating point numbers bring errors into the calculation, both inside the Lotro-client and in this function collection. This is why a 100% match with the stats in Lotro is impossible.
-- Anyway, to compensate for some errors, we use a calculation deviation correction value. This makes for instance 24.49999999 round to 25, as it's assumed that 24.5 was intended as outcome of a formula.
local DblCalcDev = 0.00000001;

_G.CalcStat = function(SName, SLvl, SParam)

	local SN = string.upper(string.match(SName,"(%w+)"));

	local L = SLvl;
	local N = 1;
	local C = "";

	if SParam ~= nil then
		if type(SParam) == "number" then
			N = SParam;
		else
			C = SParam;
		end
	end

	if SN < "PARTBLOCKPRATPC" then
		if SN < "FINESSEPBONUS" then
			if SN < "CRITDEFPRATP" then
				if SN < "BPEPRATPC" then
					if SN < "BLOCKPRATPB" then
						if SN < "BEORNINGCDCANBLOCK" then
							if SN < "ADJTRAITPROGRATINGS" then
								if SN == "-VERSION" then
									return "1.4a254p1p";
								else
									return 0;
								end
							elseif SN > "ADJTRAITPROGRATINGS" then
								if SN == "BEORNINGCDARMOURTYPE" then
									return 3;
								else
									return 0;
								end
							else
								if L-DblCalcDev <= 105 then
									return LinFmod(1,CalcStat("TraitProg",1,N),0.8*CalcStat("TraitProg",105,N),1,105,L)/CalcStat("TraitProg",L,N);
								elseif L-DblCalcDev <= 106 then
									return LinFmod(1,0.8*CalcStat("TraitProg",105,N),CalcStat("TraitProg",106,N),105,106,L)/CalcStat("TraitProg",L,N);
								elseif L-DblCalcDev <= 121 then
									return 1;
								elseif L-DblCalcDev <= 130 then
									return LinFmod(1,CalcStat("TraitProg",121,N),0.9*CalcStat("TraitProg",130,N),121,130,L)/CalcStat("TraitProg",L,N);
								else
									return 0.9;
								end
							end
						elseif SN > "BEORNINGCDCANBLOCK" then
							if SN < "BLOCKPPRAT" then
								if SN == "BLOCKPBONUS" then
									return CalcStat("BPEPBonus",L);
								else
									return 0;
								end
							elseif SN > "BLOCKPPRAT" then
								if SN > "BLOCKPRATP" then
									if SN == "BLOCKPRATPA" then
										return CalcStat("BPEPRatPA",L);
									else
										return 0;
									end
								elseif SN == "BLOCKPRATP" then
									return CalcStat("BPEPRatP",L,N);
								else
									return 0;
								end
							else
								return CalcStat("BPEPPRat",L,N);
							end
						else
							if L-DblCalcDev <= 5 then
								return 0;
							else
								return 1;
							end
						end
					elseif SN > "BLOCKPRATPB" then
						if SN < "BPEPBONUS" then
							if SN < "BLOCKPRATPCAP" then
								if SN == "BLOCKPRATPC" then
									return CalcStat("BPEPRatPC",L);
								else
									return 0;
								end
							elseif SN > "BLOCKPRATPCAP" then
								if SN == "BLOCKPRATPCAPR" then
									return CalcStat("BPEPRatPCapR",L);
								else
									return 0;
								end
							else
								return CalcStat("BPEPRatPCap",L);
							end
						elseif SN > "BPEPBONUS" then
							if SN < "BPEPRATP" then
								if SN == "BPEPPRAT" then
									return CalcRatAB(CalcStat("BPEPRatPA",L),CalcStat("BPEPRatPB",L),CalcStat("BPEPRatPCapR",L),N);
								else
									return 0;
								end
							elseif SN > "BPEPRATP" then
								if SN > "BPEPRATPA" then
									if SN == "BPEPRATPB" then
										return CalcStat("BratLow",L);
									else
										return 0;
									end
								elseif SN == "BPEPRATPA" then
									return 26;
								else
									return 0;
								end
							else
								return CalcPercAB(CalcStat("BPEPRatPA",L),CalcStat("BPEPRatPB",L),CalcStat("BPEPRatPCap",L),N);
							end
						else
							return 0;
						end
					else
						return CalcStat("BPEPRatPB",L);
					end
				elseif SN > "BPEPRATPC" then
					if SN < "BRATMITMEDIUM" then
						if SN < "BRATLOW" then
							if SN < "BPEPRATPCAPR" then
								if SN == "BPEPRATPCAP" then
									return 13;
								else
									return 0;
								end
							elseif SN > "BPEPRATPCAPR" then
								if SN == "BRATHIGH" then
									return CalcStat("BratProg",L,CalcStat("ProgBHigh",L));
								else
									return 0;
								end
							else
								return CalcStat("BPEPRatPB",L)*CalcStat("BPEPRatPC",L);
							end
						elseif SN > "BRATLOW" then
							if SN < "BRATMEDIUM" then
								if SN == "BRATMASTERY" then
									return CalcStat("BratProg",L,CalcStat("ProgBMastery",L));
								else
									return 0;
								end
							elseif SN > "BRATMEDIUM" then
								if SN > "BRATMITHEAVY" then
									if SN == "BRATMITLIGHT" then
										return CalcStat("BratProg",L,CalcStat("ProgBMitLight",L));
									else
										return 0;
									end
								elseif SN == "BRATMITHEAVY" then
									return CalcStat("BratProg",L,CalcStat("ProgBMitHeavy",L));
								else
									return 0;
								end
							else
								return CalcStat("BratProg",L,CalcStat("ProgBMedium",L));
							end
						else
							return CalcStat("BratProg",L,CalcStat("ProgBLow",L));
						end
					elseif SN > "BRATMITMEDIUM" then
						if SN < "CAPTAINCDCANBLOCK" then
							if SN < "BRATPROG" then
								if SN == "BRATPARTIAL" then
									return CalcStat("BratProg",L,CalcStat("ProgBPartial",L));
								else
									return 0;
								end
							elseif SN > "BRATPROG" then
								if SN > "BURGLARCDARMOURTYPE" then
									if SN == "CAPTAINCDARMOURTYPE" then
										return 3;
									else
										return 0;
									end
								elseif SN == "BURGLARCDARMOURTYPE" then
									return 2;
								else
									return 0;
								end
							else
								if L-DblCalcDev <= 75 then
									return LinFmod(RoundDbl(N),1,75,1,75,L);
								elseif L-DblCalcDev <= 76 then
									return LinFmod(1,RoundDbl(N)*75,CalcStat("StdProg",76,N),75,76,L);
								elseif L-DblCalcDev <= 100 then
									return LinFmod(1,CalcStat("StdProg",76,N),CalcStat("StdProg",100,N),75,100,L,-1);
								elseif L-DblCalcDev <= 101 then
									return CalcStat("StdProg",L,N);
								elseif L-DblCalcDev <= 105 then
									return LinFmod(1,CalcStat("StdProg",101,N),CalcStat("StdProg",105,N),100,105,L,-1);
								elseif L-DblCalcDev <= 106 then
									return CalcStat("StdProg",L,N);
								elseif L-DblCalcDev <= 115 then
									return LinFmod(1,CalcStat("StdProg",106,N),CalcStat("StdProg",115,N),106,115,L,-1);
								elseif L-DblCalcDev <= 116 then
									return CalcStat("StdProg",L,N);
								elseif L-DblCalcDev <= 120 then
									return LinFmod(1,CalcStat("StdProg",116,N),CalcStat("StdProg",120,N),116,120,L,-1);
								elseif L-DblCalcDev <= 121 then
									return CalcStat("StdProg",L,N);
								elseif L-DblCalcDev <= 130 then
									return LinFmod(1,CalcStat("StdProg",121,N),CalcStat("StdProg",130,N),121,130,L,-1);
								elseif L-DblCalcDev <= 131 then
									return CalcStat("StdProg",L,N);
								else
									return LinFmod(1,CalcStat("StdProg",131,N),CalcStat("StdProg",140,N),131,140,L,-1);
								end
							end
						elseif SN > "CAPTAINCDCANBLOCK" then
							if SN < "CHAMPIONCDCANBLOCK" then
								if SN == "CHAMPIONCDARMOURTYPE" then
									return 3;
								else
									return 0;
								end
							elseif SN > "CHAMPIONCDCANBLOCK" then
								if SN > "CRITDEFPBONUS" then
									if SN == "CRITDEFPPRAT" then
										return CalcRatAB(CalcStat("CritDefPRatPA",L),CalcStat("CritDefPRatPB",L),CalcStat("CritDefPRatPCapR",L),N);
									else
										return 0;
									end
								elseif SN == "CRITDEFPBONUS" then
									return 0;
								else
									return 0;
								end
							else
								if L-DblCalcDev <= 9 then
									return 0;
								else
									return 1;
								end
							end
						else
							if L-DblCalcDev <= 14 then
								return 0;
							else
								return 1;
							end
						end
					else
						return CalcStat("BratProg",L,CalcStat("ProgBMitMedium",L));
					end
				else
					return 1;
				end
			elseif SN > "CRITDEFPRATP" then
				if SN < "CRITMAGNPRATPC" then
					if SN < "CRITHITPRATPA" then
						if SN < "CRITDEFPRATPCAP" then
							if SN < "CRITDEFPRATPB" then
								if SN == "CRITDEFPRATPA" then
									return 160;
								else
									return 0;
								end
							elseif SN > "CRITDEFPRATPB" then
								if SN == "CRITDEFPRATPC" then
									return 1;
								else
									return 0;
								end
							else
								return CalcStat("BratLow",L);
							end
						elseif SN > "CRITDEFPRATPCAP" then
							if SN < "CRITHITPBONUS" then
								if SN == "CRITDEFPRATPCAPR" then
									return CalcStat("CritDefPRatPB",L)*CalcStat("CritDefPRatPC",L);
								else
									return 0;
								end
							elseif SN > "CRITHITPBONUS" then
								if SN > "CRITHITPPRAT" then
									if SN == "CRITHITPRATP" then
										return CalcPercAB(CalcStat("CritHitPRatPA",L),CalcStat("CritHitPRatPB",L),CalcStat("CritHitPRatPCap",L),N);
									else
										return 0;
									end
								elseif SN == "CRITHITPPRAT" then
									return CalcRatAB(CalcStat("CritHitPRatPA",L),CalcStat("CritHitPRatPB",L),CalcStat("CritHitPRatPCapR",L),N);
								else
									return 0;
								end
							else
								return 0;
							end
						else
							return 80;
						end
					elseif SN > "CRITHITPRATPA" then
						if SN < "CRITMAGNPBONUS" then
							if SN < "CRITHITPRATPC" then
								if SN == "CRITHITPRATPB" then
									return CalcStat("BratLow",L);
								else
									return 0;
								end
							elseif SN > "CRITHITPRATPC" then
								if SN > "CRITHITPRATPCAP" then
									if SN == "CRITHITPRATPCAPR" then
										return CalcStat("CritHitPRatPB",L)*CalcStat("CritHitPRatPC",L);
									else
										return 0;
									end
								elseif SN == "CRITHITPRATPCAP" then
									return 25;
								else
									return 0;
								end
							else
								return 1;
							end
						elseif SN > "CRITMAGNPBONUS" then
							if SN < "CRITMAGNPRATP" then
								if SN == "CRITMAGNPPRAT" then
									return CalcRatAB(CalcStat("CritMagnPRatPA",L),CalcStat("CritMagnPRatPB",L),CalcStat("CritMagnPRatPCapR",L),N);
								else
									return 0;
								end
							elseif SN > "CRITMAGNPRATP" then
								if SN > "CRITMAGNPRATPA" then
									if SN == "CRITMAGNPRATPB" then
										return CalcStat("BratHigh",L);
									else
										return 0;
									end
								elseif SN == "CRITMAGNPRATPA" then
									if L-DblCalcDev <= 120 then
										return 200;
									elseif L-DblCalcDev <= 127 then
										return (-5)*L+750;
									else
										return 112.5;
									end
								else
									return 0;
								end
							else
								return CalcPercAB(CalcStat("CritMagnPRatPA",L),CalcStat("CritMagnPRatPB",L),CalcStat("CritMagnPRatPCap",L),N);
							end
						else
							return 0;
						end
					else
						return 50;
					end
				elseif SN > "CRITMAGNPRATPC" then
					if SN < "DEVHITPRATPCAP" then
						if SN < "DEVHITPPRAT" then
							if SN < "CRITMAGNPRATPCAPR" then
								if SN == "CRITMAGNPRATPCAP" then
									if L-DblCalcDev <= 120 then
										return 100;
									else
										return 75;
									end
								else
									return 0;
								end
							elseif SN > "CRITMAGNPRATPCAPR" then
								if SN == "DEVHITPBONUS" then
									return 0;
								else
									return 0;
								end
							else
								return CalcStat("CritMagnPRatPB",L)*CalcStat("CritMagnPRatPC",L);
							end
						elseif SN > "DEVHITPPRAT" then
							if SN < "DEVHITPRATPA" then
								if SN == "DEVHITPRATP" then
									return CalcPercAB(CalcStat("DevHitPRatPA",L),CalcStat("DevHitPRatPB",L),CalcStat("DevHitPRatPCap",L),N);
								else
									return 0;
								end
							elseif SN > "DEVHITPRATPA" then
								if SN > "DEVHITPRATPB" then
									if SN == "DEVHITPRATPC" then
										return 1;
									else
										return 0;
									end
								elseif SN == "DEVHITPRATPB" then
									return CalcStat("BratMedium",L);
								else
									return 0;
								end
							else
								return 20;
							end
						else
							return CalcRatAB(CalcStat("DevHitPRatPA",L),CalcStat("DevHitPRatPB",L),CalcStat("DevHitPRatPCapR",L),N);
						end
					elseif SN > "DEVHITPRATPCAP" then
						if SN < "EVADEPRATPA" then
							if SN < "EVADEPBONUS" then
								if SN == "DEVHITPRATPCAPR" then
									return CalcStat("DevHitPRatPB",L)*CalcStat("DevHitPRatPC",L);
								else
									return 0;
								end
							elseif SN > "EVADEPBONUS" then
								if SN > "EVADEPPRAT" then
									if SN == "EVADEPRATP" then
										return CalcStat("BPEPRatP",L,N);
									else
										return 0;
									end
								elseif SN == "EVADEPPRAT" then
									return CalcStat("BPEPPRat",L,N);
								else
									return 0;
								end
							else
								return CalcStat("BPEPBonus",L);
							end
						elseif SN > "EVADEPRATPA" then
							if SN < "EVADEPRATPC" then
								if SN == "EVADEPRATPB" then
									return CalcStat("BPEPRatPB",L);
								else
									return 0;
								end
							elseif SN > "EVADEPRATPC" then
								if SN > "EVADEPRATPCAP" then
									if SN == "EVADEPRATPCAPR" then
										return CalcStat("BPEPRatPCapR",L);
									else
										return 0;
									end
								elseif SN == "EVADEPRATPCAP" then
									return CalcStat("BPEPRatPCap",L);
								else
									return 0;
								end
							else
								return CalcStat("BPEPRatPC",L);
							end
						else
							return CalcStat("BPEPRatPA",L);
						end
					else
						return 10;
					end
				else
					return CalcStat("CritMagnPRatPCap",L)/(CalcStat("CritMagnPRatPA",L)-CalcStat("CritMagnPRatPCap",L));
				end
			else
				return CalcPercAB(CalcStat("CritDefPRatPA",L),CalcStat("CritDefPRatPB",L),CalcStat("CritDefPRatPCap",L),N);
			end
		elseif SN > "FINESSEPBONUS" then
			if SN < "MITLIGHTPRATPCAPR" then
				if SN < "LEVELCAP" then
					if SN < "GUARDIANCDCANBLOCK" then
						if SN < "FINESSEPRATPB" then
							if SN < "FINESSEPRATP" then
								if SN == "FINESSEPPRAT" then
									return CalcRatAB(CalcStat("FinessePRatPA",L),CalcStat("FinessePRatPB",L),CalcStat("FinessePRatPCapR",L),N);
								else
									return 0;
								end
							elseif SN > "FINESSEPRATP" then
								if SN == "FINESSEPRATPA" then
									return 100;
								else
									return 0;
								end
							else
								return CalcPercAB(CalcStat("FinessePRatPA",L),CalcStat("FinessePRatPB",L),CalcStat("FinessePRatPCap",L),N);
							end
						elseif SN > "FINESSEPRATPB" then
							if SN < "FINESSEPRATPCAP" then
								if SN == "FINESSEPRATPC" then
									return 1;
								else
									return 0;
								end
							elseif SN > "FINESSEPRATPCAP" then
								if SN > "FINESSEPRATPCAPR" then
									if SN == "GUARDIANCDARMOURTYPE" then
										return 3;
									else
										return 0;
									end
								elseif SN == "FINESSEPRATPCAPR" then
									return CalcStat("FinessePRatPB",L)*CalcStat("FinessePRatPC",L);
								else
									return 0;
								end
							else
								return 50;
							end
						else
							return CalcStat("BratLow",L);
						end
					elseif SN > "GUARDIANCDCANBLOCK" then
						if SN < "INHEALPRATPA" then
							if SN < "INHEALPBONUS" then
								if SN == "HUNTERCDARMOURTYPE" then
									return 2;
								else
									return 0;
								end
							elseif SN > "INHEALPBONUS" then
								if SN > "INHEALPPRAT" then
									if SN == "INHEALPRATP" then
										return CalcPercAB(CalcStat("InHealPRatPA",L),CalcStat("InHealPRatPB",L),CalcStat("InHealPRatPCap",L),N);
									else
										return 0;
									end
								elseif SN == "INHEALPPRAT" then
									return CalcRatAB(CalcStat("InHealPRatPA",L),CalcStat("InHealPRatPB",L),CalcStat("InHealPRatPCapR",L),N);
								else
									return 0;
								end
							else
								return 0;
							end
						elseif SN > "INHEALPRATPA" then
							if SN < "INHEALPRATPC" then
								if SN == "INHEALPRATPB" then
									return CalcStat("BratLow",L);
								else
									return 0;
								end
							elseif SN > "INHEALPRATPC" then
								if SN > "INHEALPRATPCAP" then
									if SN == "INHEALPRATPCAPR" then
										return CalcStat("InHealPRatPB",L)*CalcStat("InHealPRatPC",L);
									else
										return 0;
									end
								elseif SN == "INHEALPRATPCAP" then
									return 25;
								else
									return 0;
								end
							else
								return 1;
							end
						else
							return 50;
						end
					else
						return 1;
					end
				elseif SN > "LEVELCAP" then
					if SN < "MITHEAVYPRATPC" then
						if SN < "MITHEAVYPBONUS" then
							if SN < "MINSTRELCDARMOURTYPE" then
								if SN == "LOREMASTERCDARMOURTYPE" then
									return 1;
								else
									return 0;
								end
							elseif SN > "MINSTRELCDARMOURTYPE" then
								if SN == "MINSTRELCDCANBLOCK" then
									if L-DblCalcDev <= 19 then
										return 0;
									else
										return 1;
									end
								else
									return 0;
								end
							else
								return 1;
							end
						elseif SN > "MITHEAVYPBONUS" then
							if SN < "MITHEAVYPRATP" then
								if SN == "MITHEAVYPPRAT" then
									return CalcRatAB(CalcStat("MitHeavyPRatPA",L),CalcStat("MitHeavyPRatPB",L),CalcStat("MitHeavyPRatPCapR",L),N);
								else
									return 0;
								end
							elseif SN > "MITHEAVYPRATP" then
								if SN > "MITHEAVYPRATPA" then
									if SN == "MITHEAVYPRATPB" then
										return CalcStat("BratMitHeavy",L);
									else
										return 0;
									end
								elseif SN == "MITHEAVYPRATPA" then
									return 110;
								else
									return 0;
								end
							else
								return CalcPercAB(CalcStat("MitHeavyPRatPA",L),CalcStat("MitHeavyPRatPB",L),CalcStat("MitHeavyPRatPCap",L),N);
							end
						else
							return 0;
						end
					elseif SN > "MITHEAVYPRATPC" then
						if SN < "MITLIGHTPRATP" then
							if SN < "MITHEAVYPRATPCAPR" then
								if SN == "MITHEAVYPRATPCAP" then
									return 60;
								else
									return 0;
								end
							elseif SN > "MITHEAVYPRATPCAPR" then
								if SN > "MITLIGHTPBONUS" then
									if SN == "MITLIGHTPPRAT" then
										return CalcRatAB(CalcStat("MitLightPRatPA",L),CalcStat("MitLightPRatPB",L),CalcStat("MitLightPRatPCapR",L),N);
									else
										return 0;
									end
								elseif SN == "MITLIGHTPBONUS" then
									return 0;
								else
									return 0;
								end
							else
								return CalcStat("MitHeavyPRatPB",L)*CalcStat("MitHeavyPRatPC",L);
							end
						elseif SN > "MITLIGHTPRATP" then
							if SN < "MITLIGHTPRATPB" then
								if SN == "MITLIGHTPRATPA" then
									return 65;
								else
									return 0;
								end
							elseif SN > "MITLIGHTPRATPB" then
								if SN > "MITLIGHTPRATPC" then
									if SN == "MITLIGHTPRATPCAP" then
										return 40;
									else
										return 0;
									end
								elseif SN == "MITLIGHTPRATPC" then
									return 1.6;
								else
									return 0;
								end
							else
								return CalcStat("BratMitLight",L);
							end
						else
							return CalcPercAB(CalcStat("MitLightPRatPA",L),CalcStat("MitLightPRatPB",L),CalcStat("MitLightPRatPCap",L),N);
						end
					else
						return 1.2;
					end
				else
					return 130;
				end
			elseif SN > "MITLIGHTPRATPCAPR" then
				if SN < "PARRYPRATP" then
					if SN < "OUTHEALPBONUS" then
						if SN < "MITMEDIUMPRATPA" then
							if SN < "MITMEDIUMPPRAT" then
								if SN == "MITMEDIUMPBONUS" then
									return 0;
								else
									return 0;
								end
							elseif SN > "MITMEDIUMPPRAT" then
								if SN == "MITMEDIUMPRATP" then
									return CalcPercAB(CalcStat("MitMediumPRatPA",L),CalcStat("MitMediumPRatPB",L),CalcStat("MitMediumPRatPCap",L),N);
								else
									return 0;
								end
							else
								return CalcRatAB(CalcStat("MitMediumPRatPA",L),CalcStat("MitMediumPRatPB",L),CalcStat("MitMediumPRatPCapR",L),N);
							end
						elseif SN > "MITMEDIUMPRATPA" then
							if SN < "MITMEDIUMPRATPC" then
								if SN == "MITMEDIUMPRATPB" then
									return CalcStat("BratMitMedium",L);
								else
									return 0;
								end
							elseif SN > "MITMEDIUMPRATPC" then
								if SN > "MITMEDIUMPRATPCAP" then
									if SN == "MITMEDIUMPRATPCAPR" then
										return CalcStat("MitMediumPRatPB",L)*CalcStat("MitMediumPRatPC",L);
									else
										return 0;
									end
								elseif SN == "MITMEDIUMPRATPCAP" then
									return 50;
								else
									return 0;
								end
							else
								return 10/7;
							end
						else
							return 85;
						end
					elseif SN > "OUTHEALPBONUS" then
						if SN < "OUTHEALPRATPC" then
							if SN < "OUTHEALPRATP" then
								if SN == "OUTHEALPPRAT" then
									return CalcRatAB(CalcStat("OutHealPRatPA",L),CalcStat("OutHealPRatPB",L),CalcStat("OutHealPRatPCapR",L),N);
								else
									return 0;
								end
							elseif SN > "OUTHEALPRATP" then
								if SN > "OUTHEALPRATPA" then
									if SN == "OUTHEALPRATPB" then
										return CalcStat("BratMedium",L);
									else
										return 0;
									end
								elseif SN == "OUTHEALPRATPA" then
									return 140;
								else
									return 0;
								end
							else
								return CalcPercAB(CalcStat("OutHealPRatPA",L),CalcStat("OutHealPRatPB",L),CalcStat("OutHealPRatPCap",L),N);
							end
						elseif SN > "OUTHEALPRATPC" then
							if SN < "OUTHEALPRATPCAPR" then
								if SN == "OUTHEALPRATPCAP" then
									return 70;
								else
									return 0;
								end
							elseif SN > "OUTHEALPRATPCAPR" then
								if SN > "PARRYPBONUS" then
									if SN == "PARRYPPRAT" then
										return CalcStat("BPEPPRat",L,N);
									else
										return 0;
									end
								elseif SN == "PARRYPBONUS" then
									return CalcStat("BPEPBonus",L);
								else
									return 0;
								end
							else
								return CalcStat("OutHealPRatPB",L)*CalcStat("OutHealPRatPC",L);
							end
						else
							return 1;
						end
					else
						return 0;
					end
				elseif SN > "PARRYPRATP" then
					if SN < "PARTBLOCKMITPRATPA" then
						if SN < "PARRYPRATPCAP" then
							if SN < "PARRYPRATPB" then
								if SN == "PARRYPRATPA" then
									return CalcStat("BPEPRatPA",L);
								else
									return 0;
								end
							elseif SN > "PARRYPRATPB" then
								if SN == "PARRYPRATPC" then
									return CalcStat("BPEPRatPC",L);
								else
									return 0;
								end
							else
								return CalcStat("BPEPRatPB",L);
							end
						elseif SN > "PARRYPRATPCAP" then
							if SN < "PARTBLOCKMITPBONUS" then
								if SN == "PARRYPRATPCAPR" then
									return CalcStat("BPEPRatPCapR",L);
								else
									return 0;
								end
							elseif SN > "PARTBLOCKMITPBONUS" then
								if SN > "PARTBLOCKMITPPRAT" then
									if SN == "PARTBLOCKMITPRATP" then
										return CalcStat("PartMitPRatP",L,N);
									else
										return 0;
									end
								elseif SN == "PARTBLOCKMITPPRAT" then
									return CalcStat("PartMitPPRat",L,N);
								else
									return 0;
								end
							else
								return CalcStat("PartMitPBonus",L);
							end
						else
							return CalcStat("BPEPRatPCap",L);
						end
					elseif SN > "PARTBLOCKMITPRATPA" then
						if SN < "PARTBLOCKPBONUS" then
							if SN < "PARTBLOCKMITPRATPC" then
								if SN == "PARTBLOCKMITPRATPB" then
									return CalcStat("PartMitPRatPB",L);
								else
									return 0;
								end
							elseif SN > "PARTBLOCKMITPRATPC" then
								if SN > "PARTBLOCKMITPRATPCAP" then
									if SN == "PARTBLOCKMITPRATPCAPR" then
										return CalcStat("PartMitPRatPCapR",L);
									else
										return 0;
									end
								elseif SN == "PARTBLOCKMITPRATPCAP" then
									return CalcStat("PartMitPRatPCap",L);
								else
									return 0;
								end
							else
								return CalcStat("PartMitPRatPC",L);
							end
						elseif SN > "PARTBLOCKPBONUS" then
							if SN < "PARTBLOCKPRATP" then
								if SN == "PARTBLOCKPPRAT" then
									return CalcStat("PartBPEPPRat",L,N);
								else
									return 0;
								end
							elseif SN > "PARTBLOCKPRATP" then
								if SN > "PARTBLOCKPRATPA" then
									if SN == "PARTBLOCKPRATPB" then
										return CalcStat("PartBPEPRatPB",L);
									else
										return 0;
									end
								elseif SN == "PARTBLOCKPRATPA" then
									return CalcStat("PartBPEPRatPA",L);
								else
									return 0;
								end
							else
								return CalcStat("PartBPEPRatP",L,N);
							end
						else
							return CalcStat("PartBPEPBonus",L);
						end
					else
						return CalcStat("PartMitPRatPA",L);
					end
				else
					return CalcStat("BPEPRatP",L,N);
				end
			else
				return CalcStat("MitLightPRatPB",L)*CalcStat("MitLightPRatPC",L);
			end
		else
			return 0;
		end
	elseif SN > "PARTBLOCKPRATPC" then
		if SN < "PHYMITMPBONUS" then
			if SN < "PARTPARRYMITPRATP" then
				if SN < "PARTEVADEMITPRATPCAPR" then
					if SN < "PARTBPEPRATPCAP" then
						if SN < "PARTBPEPPRAT" then
							if SN < "PARTBLOCKPRATPCAPR" then
								if SN == "PARTBLOCKPRATPCAP" then
									return CalcStat("PartBPEPRatPCap",L);
								else
									return 0;
								end
							elseif SN > "PARTBLOCKPRATPCAPR" then
								if SN == "PARTBPEPBONUS" then
									return 0;
								else
									return 0;
								end
							else
								return CalcStat("PartBPEPRatPCapR",L);
							end
						elseif SN > "PARTBPEPPRAT" then
							if SN < "PARTBPEPRATPA" then
								if SN == "PARTBPEPRATP" then
									return CalcPercAB(CalcStat("PartBPEPRatPA",L),CalcStat("PartBPEPRatPB",L),CalcStat("PartBPEPRatPCap",L),N);
								else
									return 0;
								end
							elseif SN > "PARTBPEPRATPA" then
								if SN > "PARTBPEPRATPB" then
									if SN == "PARTBPEPRATPC" then
										return 1;
									else
										return 0;
									end
								elseif SN == "PARTBPEPRATPB" then
									return CalcStat("BratPartial",L);
								else
									return 0;
								end
							else
								return 70;
							end
						else
							return CalcRatAB(CalcStat("PartBPEPRatPA",L),CalcStat("PartBPEPRatPB",L),CalcStat("PartBPEPRatPCapR",L),N);
						end
					elseif SN > "PARTBPEPRATPCAP" then
						if SN < "PARTEVADEMITPRATP" then
							if SN < "PARTEVADEMITPBONUS" then
								if SN == "PARTBPEPRATPCAPR" then
									return CalcStat("PartBPEPRatPB",L)*CalcStat("PartBPEPRatPC",L);
								else
									return 0;
								end
							elseif SN > "PARTEVADEMITPBONUS" then
								if SN == "PARTEVADEMITPPRAT" then
									return CalcStat("PartMitPPRat",L,N);
								else
									return 0;
								end
							else
								if L-DblCalcDev <= 1 then
									return 35;
								else
									return CalcStat("PartMitPBonus",L);
								end
							end
						elseif SN > "PARTEVADEMITPRATP" then
							if SN < "PARTEVADEMITPRATPB" then
								if SN == "PARTEVADEMITPRATPA" then
									return CalcStat("PartMitPRatPA",L);
								else
									return 0;
								end
							elseif SN > "PARTEVADEMITPRATPB" then
								if SN > "PARTEVADEMITPRATPC" then
									if SN == "PARTEVADEMITPRATPCAP" then
										return CalcStat("PartMitPRatPCap",L);
									else
										return 0;
									end
								elseif SN == "PARTEVADEMITPRATPC" then
									return CalcStat("PartMitPRatPC",L);
								else
									return 0;
								end
							else
								return CalcStat("PartMitPRatPB",L);
							end
						else
							return CalcStat("PartMitPRatP",L,N);
						end
					else
						return 35;
					end
				elseif SN > "PARTEVADEMITPRATPCAPR" then
					if SN < "PARTMITPBONUS" then
						if SN < "PARTEVADEPRATPA" then
							if SN < "PARTEVADEPPRAT" then
								if SN == "PARTEVADEPBONUS" then
									return CalcStat("PartBPEPBonus",L);
								else
									return 0;
								end
							elseif SN > "PARTEVADEPPRAT" then
								if SN == "PARTEVADEPRATP" then
									return CalcStat("PartBPEPRatP",L,N);
								else
									return 0;
								end
							else
								return CalcStat("PartBPEPPRat",L,N);
							end
						elseif SN > "PARTEVADEPRATPA" then
							if SN < "PARTEVADEPRATPC" then
								if SN == "PARTEVADEPRATPB" then
									return CalcStat("PartBPEPRatPB",L);
								else
									return 0;
								end
							elseif SN > "PARTEVADEPRATPC" then
								if SN > "PARTEVADEPRATPCAP" then
									if SN == "PARTEVADEPRATPCAPR" then
										return CalcStat("PartBPEPRatPCapR",L);
									else
										return 0;
									end
								elseif SN == "PARTEVADEPRATPCAP" then
									return CalcStat("PartBPEPRatPCap",L);
								else
									return 0;
								end
							else
								return CalcStat("PartBPEPRatPC",L);
							end
						else
							return CalcStat("PartBPEPRatPA",L);
						end
					elseif SN > "PARTMITPBONUS" then
						if SN < "PARTMITPRATPC" then
							if SN < "PARTMITPRATP" then
								if SN == "PARTMITPPRAT" then
									return CalcRatAB(CalcStat("PartMitPRatPA",L),CalcStat("PartMitPRatPB",L),CalcStat("PartMitPRatPCapR",L),N);
								else
									return 0;
								end
							elseif SN > "PARTMITPRATP" then
								if SN > "PARTMITPRATPA" then
									if SN == "PARTMITPRATPB" then
										return CalcStat("BratPartial",L);
									else
										return 0;
									end
								elseif SN == "PARTMITPRATPA" then
									return 100;
								else
									return 0;
								end
							else
								return CalcPercAB(CalcStat("PartMitPRatPA",L),CalcStat("PartMitPRatPB",L),CalcStat("PartMitPRatPCap",L),N);
							end
						elseif SN > "PARTMITPRATPC" then
							if SN < "PARTMITPRATPCAPR" then
								if SN == "PARTMITPRATPCAP" then
									return 50;
								else
									return 0;
								end
							elseif SN > "PARTMITPRATPCAPR" then
								if SN > "PARTPARRYMITPBONUS" then
									if SN == "PARTPARRYMITPPRAT" then
										return CalcStat("PartMitPPRat",L,N);
									else
										return 0;
									end
								elseif SN == "PARTPARRYMITPBONUS" then
									return CalcStat("PartMitPBonus",L);
								else
									return 0;
								end
							else
								return CalcStat("PartMitPRatPB",L)*CalcStat("PartMitPRatPC",L);
							end
						else
							return 1;
						end
					else
						return 10;
					end
				else
					return CalcStat("PartMitPRatPCapR",L);
				end
			elseif SN > "PARTPARRYMITPRATP" then
				if SN < "PHYDMGPRATPC" then
					if SN < "PARTPARRYPRATPA" then
						if SN < "PARTPARRYMITPRATPCAP" then
							if SN < "PARTPARRYMITPRATPB" then
								if SN == "PARTPARRYMITPRATPA" then
									return CalcStat("PartMitPRatPA",L);
								else
									return 0;
								end
							elseif SN > "PARTPARRYMITPRATPB" then
								if SN == "PARTPARRYMITPRATPC" then
									return CalcStat("PartMitPRatPC",L);
								else
									return 0;
								end
							else
								return CalcStat("PartMitPRatPB",L);
							end
						elseif SN > "PARTPARRYMITPRATPCAP" then
							if SN < "PARTPARRYPBONUS" then
								if SN == "PARTPARRYMITPRATPCAPR" then
									return CalcStat("PartMitPRatPCapR",L);
								else
									return 0;
								end
							elseif SN > "PARTPARRYPBONUS" then
								if SN > "PARTPARRYPPRAT" then
									if SN == "PARTPARRYPRATP" then
										return CalcStat("PartBPEPRatP",L,N);
									else
										return 0;
									end
								elseif SN == "PARTPARRYPPRAT" then
									return CalcStat("PartBPEPPRat",L,N);
								else
									return 0;
								end
							else
								return CalcStat("PartBPEPBonus",L);
							end
						else
							return CalcStat("PartMitPRatPCap",L);
						end
					elseif SN > "PARTPARRYPRATPA" then
						if SN < "PHYDMGPBONUS" then
							if SN < "PARTPARRYPRATPC" then
								if SN == "PARTPARRYPRATPB" then
									return CalcStat("PartBPEPRatPB",L);
								else
									return 0;
								end
							elseif SN > "PARTPARRYPRATPC" then
								if SN > "PARTPARRYPRATPCAP" then
									if SN == "PARTPARRYPRATPCAPR" then
										return CalcStat("PartBPEPRatPCapR",L);
									else
										return 0;
									end
								elseif SN == "PARTPARRYPRATPCAP" then
									return CalcStat("PartBPEPRatPCap",L);
								else
									return 0;
								end
							else
								return CalcStat("PartBPEPRatPC",L);
							end
						elseif SN > "PHYDMGPBONUS" then
							if SN < "PHYDMGPRATP" then
								if SN == "PHYDMGPPRAT" then
									return CalcRatAB(CalcStat("PhyDmgPRatPA",L),CalcStat("PhyDmgPRatPB",L),CalcStat("PhyDmgPRatPCapR",L),N);
								else
									return 0;
								end
							elseif SN > "PHYDMGPRATP" then
								if SN > "PHYDMGPRATPA" then
									if SN == "PHYDMGPRATPB" then
										return CalcStat("BratMastery",L);
									else
										return 0;
									end
								elseif SN == "PHYDMGPRATPA" then
									return 400;
								else
									return 0;
								end
							else
								return CalcPercAB(CalcStat("PhyDmgPRatPA",L),CalcStat("PhyDmgPRatPB",L),CalcStat("PhyDmgPRatPCap",L),N);
							end
						else
							return 0;
						end
					else
						return CalcStat("PartBPEPRatPA",L);
					end
				elseif SN > "PHYDMGPRATPC" then
					if SN < "PHYMITHPRATPCAP" then
						if SN < "PHYMITHPPRAT" then
							if SN < "PHYDMGPRATPCAPR" then
								if SN == "PHYDMGPRATPCAP" then
									return 200;
								else
									return 0;
								end
							elseif SN > "PHYDMGPRATPCAPR" then
								if SN == "PHYMITHPBONUS" then
									return CalcStat("MitHeavyPBonus",L);
								else
									return 0;
								end
							else
								return CalcStat("PhyDmgPRatPB",L)*CalcStat("PhyDmgPRatPC",L);
							end
						elseif SN > "PHYMITHPPRAT" then
							if SN < "PHYMITHPRATPA" then
								if SN == "PHYMITHPRATP" then
									return CalcStat("MitHeavyPRatP",L,N);
								else
									return 0;
								end
							elseif SN > "PHYMITHPRATPA" then
								if SN > "PHYMITHPRATPB" then
									if SN == "PHYMITHPRATPC" then
										return CalcStat("MitHeavyPRatPC",L);
									else
										return 0;
									end
								elseif SN == "PHYMITHPRATPB" then
									return CalcStat("MitHeavyPRatPB",L);
								else
									return 0;
								end
							else
								return CalcStat("MitHeavyPRatPA",L);
							end
						else
							return CalcStat("MitHeavyPPRat",L,N);
						end
					elseif SN > "PHYMITHPRATPCAP" then
						if SN < "PHYMITLPRATPA" then
							if SN < "PHYMITLPBONUS" then
								if SN == "PHYMITHPRATPCAPR" then
									return CalcStat("MitHeavyPRatPCapR",L);
								else
									return 0;
								end
							elseif SN > "PHYMITLPBONUS" then
								if SN > "PHYMITLPPRAT" then
									if SN == "PHYMITLPRATP" then
										return CalcStat("MitLightPRatP",L,N);
									else
										return 0;
									end
								elseif SN == "PHYMITLPPRAT" then
									return CalcStat("MitLightPPRat",L,N);
								else
									return 0;
								end
							else
								return CalcStat("MitLightPBonus",L);
							end
						elseif SN > "PHYMITLPRATPA" then
							if SN < "PHYMITLPRATPC" then
								if SN == "PHYMITLPRATPB" then
									return CalcStat("MitLightPRatPB",L);
								else
									return 0;
								end
							elseif SN > "PHYMITLPRATPC" then
								if SN > "PHYMITLPRATPCAP" then
									if SN == "PHYMITLPRATPCAPR" then
										return CalcStat("MitLightPRatPCapR",L);
									else
										return 0;
									end
								elseif SN == "PHYMITLPRATPCAP" then
									return CalcStat("MitLightPRatPCap",L);
								else
									return 0;
								end
							else
								return CalcStat("MitLightPRatPC",L);
							end
						else
							return CalcStat("MitLightPRatPA",L);
						end
					else
						return CalcStat("MitHeavyPRatPCap",L);
					end
				else
					return 1;
				end
			else
				return CalcStat("PartMitPRatP",L,N);
			end
		elseif SN > "PHYMITMPBONUS" then
			if SN < "TACDMGPPRAT" then
				if SN < "PROGBPARTIAL" then
					if SN < "PNTMPDEFENCE" then
						if SN < "PHYMITMPRATPB" then
							if SN < "PHYMITMPRATP" then
								if SN == "PHYMITMPPRAT" then
									return CalcStat("MitMediumPPRat",L,N);
								else
									return 0;
								end
							elseif SN > "PHYMITMPRATP" then
								if SN == "PHYMITMPRATPA" then
									return CalcStat("MitMediumPRatPA",L);
								else
									return 0;
								end
							else
								return CalcStat("MitMediumPRatP",L,N);
							end
						elseif SN > "PHYMITMPRATPB" then
							if SN < "PHYMITMPRATPCAP" then
								if SN == "PHYMITMPRATPC" then
									return CalcStat("MitMediumPRatPC",L);
								else
									return 0;
								end
							elseif SN > "PHYMITMPRATPCAP" then
								if SN > "PHYMITMPRATPCAPR" then
									if SN == "PHYMITT" then
										return CalcStat("PntMPPhyMit",L)*CalcStat("TraitProg",L,CalcStat("ProgBMitigation",L))*CalcStat("AdjTraitProgRatings",L,CalcStat("ProgBMitigation",L))*N;
									else
										return 0;
									end
								elseif SN == "PHYMITMPRATPCAPR" then
									return CalcStat("MitMediumPRatPCapR",L);
								else
									return 0;
								end
							else
								return CalcStat("MitMediumPRatPCap",L);
							end
						else
							return CalcStat("MitMediumPRatPB",L);
						end
					elseif SN > "PNTMPDEFENCE" then
						if SN < "PROGBMEDIUM" then
							if SN < "PROGBHIGH" then
								if SN == "PNTMPPHYMIT" then
									return 45/380;
								else
									return 0;
								end
							elseif SN > "PROGBHIGH" then
								if SN > "PROGBLOW" then
									if SN == "PROGBMASTERY" then
										return 270;
									else
										return 0;
									end
								elseif SN == "PROGBLOW" then
									return 200;
								else
									return 0;
								end
							else
								return 500;
							end
						elseif SN > "PROGBMEDIUM" then
							if SN < "PROGBMITIGATION" then
								if SN == "PROGBMITHEAVY" then
									return 174;
								else
									return 0;
								end
							elseif SN > "PROGBMITIGATION" then
								if SN > "PROGBMITLIGHT" then
									if SN == "PROGBMITMEDIUM" then
										return 382/3;
									else
										return 0;
									end
								elseif SN == "PROGBMITLIGHT" then
									return 280/3;
								else
									return 0;
								end
							else
								return CalcStat("ProgBMitMedium",L);
							end
						else
							return 400;
						end
					else
						return 390/13000;
					end
				elseif SN > "PROGBPARTIAL" then
					if SN < "RESISTPRATPCAPR" then
						if SN < "RESISTPRATP" then
							if SN < "RESISTPBONUS" then
								if SN == "RATDEFENCET" then
									return CalcStat("PntMPDefence",L)*CalcStat("TraitProg",L,CalcStat("ProgBMedium",L))*CalcStat("AdjTraitProgRatings",L,CalcStat("ProgBMedium",L))*N;
								else
									return 0;
								end
							elseif SN > "RESISTPBONUS" then
								if SN == "RESISTPPRAT" then
									return CalcRatAB(CalcStat("ResistPRatPA",L),CalcStat("ResistPRatPB",L),CalcStat("ResistPRatPCapR",L),N);
								else
									return 0;
								end
							else
								return 0;
							end
						elseif SN > "RESISTPRATP" then
							if SN < "RESISTPRATPB" then
								if SN == "RESISTPRATPA" then
									return 100;
								else
									return 0;
								end
							elseif SN > "RESISTPRATPB" then
								if SN > "RESISTPRATPC" then
									if SN == "RESISTPRATPCAP" then
										return 50;
									else
										return 0;
									end
								elseif SN == "RESISTPRATPC" then
									return 1;
								else
									return 0;
								end
							else
								return CalcStat("BratLow",L);
							end
						else
							return CalcPercAB(CalcStat("ResistPRatPA",L),CalcStat("ResistPRatPB",L),CalcStat("ResistPRatPCap",L),N);
						end
					elseif SN > "RESISTPRATPCAPR" then
						if SN < "T2PENARMOUR" then
							if SN < "RUNEKEEPERCDARMOURTYPE" then
								if SN == "RESISTT" then
									return CalcStat("RatDefenceT",L,N);
								else
									return 0;
								end
							elseif SN > "RUNEKEEPERCDARMOURTYPE" then
								if SN > "STATPROG" then
									if SN == "STDPROG" then
										if L-DblCalcDev <= 75 then
											return LinFmod(N,1,75,1,75,L);
										elseif L-DblCalcDev <= 76 then
											return LinFmod(1,N*75,RoundDbl(N*82.5,-2),75,76,L);
										elseif L-DblCalcDev <= 100 then
											return LinFmod(1,RoundDbl(N*82.5,-2),N*150,76,100,L);
										elseif L-DblCalcDev <= 101 then
											return LinFmod(N,150,165,100,101,L);
										elseif L-DblCalcDev <= 105 then
											return LinFmod(N,165,225,101,105,L);
										elseif L-DblCalcDev <= 106 then
											return LinFmod(N,225,270,105,106,L);
										elseif L-DblCalcDev <= 115 then
											return LinFmod(N,270,450,106,115,L);
										elseif L-DblCalcDev <= 116 then
											return LinFmod(N,450,495,115,116,L);
										elseif L-DblCalcDev <= 120 then
											return LinFmod(N,495,1125,116,120,L);
										elseif L-DblCalcDev <= 121 then
											return LinFmod(N,1125,1575,120,121,L);
										elseif L-DblCalcDev <= 130 then
											return LinFmod(N,1575,3150,121,130,L);
										elseif L-DblCalcDev <= 131 then
											return LinFmod(N,3150,3780,130,131,L);
										else
											return LinFmod(N,3780,6300,130,140,L);
										end
									else
										return 0;
									end
								elseif SN == "STATPROG" then
									if L-DblCalcDev <= 75 then
										return LinFmod(RoundDbl(N),1,75,1,75,L);
									elseif L-DblCalcDev <= 76 then
										return LinFmod(1,RoundDbl(N)*75,CalcStat("StdProg",76,N),75,76,L);
									else
										return CalcStat("StdProg",L,N);
									end
								else
									return 0;
								end
							else
								return 1;
							end
						elseif SN > "T2PENARMOUR" then
							if SN < "T2PENMIT" then
								if SN == "T2PENBPE" then
									if L-DblCalcDev <= 115 then
										return (-40)*L;
									elseif L-DblCalcDev <= 116 then
										return ExpFmod(CalcStat("T2penBPE",115),116,20,L);
									elseif L-DblCalcDev <= 120 then
										return ExpFmod(CalcStat("T2penBPE",116),117,5.5,L);
									elseif L-DblCalcDev <= 121 then
										return ExpFmod(CalcStat("T2penBPE",120),121,20,L);
									elseif L-DblCalcDev <= 125 then
										return ExpFmod(CalcStat("T2penBPE",121),122,5.5,L);
									elseif L-DblCalcDev <= 126 then
										return ExpFmod(CalcStat("T2penBPE",125),126,20,L);
									else
										return ExpFmod(CalcStat("T2penBPE",126),127,5.5,L);
									end
								else
									return 0;
								end
							elseif SN > "T2PENMIT" then
								if SN > "T2PENRESIST" then
									if SN == "TACDMGPBONUS" then
										return 0;
									else
										return 0;
									end
								elseif SN == "T2PENRESIST" then
									if L-DblCalcDev <= 115 then
										return (-90)*L;
									elseif L-DblCalcDev <= 116 then
										return ExpFmod(CalcStat("T2penResist",115),116,20,L);
									elseif L-DblCalcDev <= 120 then
										return ExpFmod(CalcStat("T2penResist",116),117,5.5,L);
									elseif L-DblCalcDev <= 121 then
										return ExpFmod(CalcStat("T2penResist",120),121,20,L);
									elseif L-DblCalcDev <= 125 then
										return ExpFmod(CalcStat("T2penResist",121),122,5.5,L);
									elseif L-DblCalcDev <= 126 then
										return ExpFmod(CalcStat("T2penResist",125),126,20,L);
									else
										return ExpFmod(CalcStat("T2penResist",126),127,5.5,L);
									end
								else
									return 0;
								end
							else
								if L-DblCalcDev <= 115 then
									return FloorDbl(L*13.5)*-5;
								elseif L-DblCalcDev <= 116 then
									return ExpFmod(CalcStat("T2penMit",115),116,20,L);
								elseif L-DblCalcDev <= 120 then
									return ExpFmod(CalcStat("T2penMit",116),117,5.5,L);
								elseif L-DblCalcDev <= 121 then
									return ExpFmod(CalcStat("T2penMit",120),121,20,L);
								elseif L-DblCalcDev <= 125 then
									return ExpFmod(CalcStat("T2penMit",121),122,5.5,L);
								elseif L-DblCalcDev <= 126 then
									return ExpFmod(CalcStat("T2penMit",125),126,20,L);
								else
									return ExpFmod(CalcStat("T2penMit",126),127,5.5,L);
								end
							end
						else
							return CalcStat("T2penMit",L);
						end
					else
						return CalcStat("ResistPRatPB",L)*CalcStat("ResistPRatPC",L);
					end
				else
					return 350;
				end
			elseif SN > "TACDMGPPRAT" then
				if SN < "TACMITLPRATPB" then
					if SN < "TACMITHPRATP" then
						if SN < "TACDMGPRATPC" then
							if SN < "TACDMGPRATPA" then
								if SN == "TACDMGPRATP" then
									return CalcPercAB(CalcStat("TacDmgPRatPA",L),CalcStat("TacDmgPRatPB",L),CalcStat("TacDmgPRatPCap",L),N);
								else
									return 0;
								end
							elseif SN > "TACDMGPRATPA" then
								if SN == "TACDMGPRATPB" then
									return CalcStat("BratMastery",L);
								else
									return 0;
								end
							else
								return 400;
							end
						elseif SN > "TACDMGPRATPC" then
							if SN < "TACDMGPRATPCAPR" then
								if SN == "TACDMGPRATPCAP" then
									return 200;
								else
									return 0;
								end
							elseif SN > "TACDMGPRATPCAPR" then
								if SN > "TACMITHPBONUS" then
									if SN == "TACMITHPPRAT" then
										return CalcStat("MitHeavyPPRat",L,N);
									else
										return 0;
									end
								elseif SN == "TACMITHPBONUS" then
									return CalcStat("MitHeavyPBonus",L);
								else
									return 0;
								end
							else
								return CalcStat("TacDmgPRatPB",L)*CalcStat("TacDmgPRatPC",L);
							end
						else
							return 1;
						end
					elseif SN > "TACMITHPRATP" then
						if SN < "TACMITHPRATPCAPR" then
							if SN < "TACMITHPRATPB" then
								if SN == "TACMITHPRATPA" then
									return CalcStat("MitHeavyPRatPA",L);
								else
									return 0;
								end
							elseif SN > "TACMITHPRATPB" then
								if SN > "TACMITHPRATPC" then
									if SN == "TACMITHPRATPCAP" then
										return CalcStat("MitHeavyPRatPCap",L);
									else
										return 0;
									end
								elseif SN == "TACMITHPRATPC" then
									return CalcStat("MitHeavyPRatPC",L);
								else
									return 0;
								end
							else
								return CalcStat("MitHeavyPRatPB",L);
							end
						elseif SN > "TACMITHPRATPCAPR" then
							if SN < "TACMITLPPRAT" then
								if SN == "TACMITLPBONUS" then
									return CalcStat("MitLightPBonus",L);
								else
									return 0;
								end
							elseif SN > "TACMITLPPRAT" then
								if SN > "TACMITLPRATP" then
									if SN == "TACMITLPRATPA" then
										return CalcStat("MitLightPRatPA",L);
									else
										return 0;
									end
								elseif SN == "TACMITLPRATP" then
									return CalcStat("MitLightPRatP",L,N);
								else
									return 0;
								end
							else
								return CalcStat("MitLightPPRat",L,N);
							end
						else
							return CalcStat("MitHeavyPRatPCapR",L);
						end
					else
						return CalcStat("MitHeavyPRatP",L,N);
					end
				elseif SN > "TACMITLPRATPB" then
					if SN < "TACMITMPRATPC" then
						if SN < "TACMITMPBONUS" then
							if SN < "TACMITLPRATPCAP" then
								if SN == "TACMITLPRATPC" then
									return CalcStat("MitLightPRatPC",L);
								else
									return 0;
								end
							elseif SN > "TACMITLPRATPCAP" then
								if SN == "TACMITLPRATPCAPR" then
									return CalcStat("MitLightPRatPCapR",L);
								else
									return 0;
								end
							else
								return CalcStat("MitLightPRatPCap",L);
							end
						elseif SN > "TACMITMPBONUS" then
							if SN < "TACMITMPRATP" then
								if SN == "TACMITMPPRAT" then
									return CalcStat("MitMediumPPRat",L,N);
								else
									return 0;
								end
							elseif SN > "TACMITMPRATP" then
								if SN > "TACMITMPRATPA" then
									if SN == "TACMITMPRATPB" then
										return CalcStat("MitMediumPRatPB",L);
									else
										return 0;
									end
								elseif SN == "TACMITMPRATPA" then
									return CalcStat("MitMediumPRatPA",L);
								else
									return 0;
								end
							else
								return CalcStat("MitMediumPRatP",L,N);
							end
						else
							return CalcStat("MitMediumPBonus",L);
						end
					elseif SN > "TACMITMPRATPC" then
						if SN < "TPENCHOICE" then
							if SN < "TACMITMPRATPCAPR" then
								if SN == "TACMITMPRATPCAP" then
									return CalcStat("MitMediumPRatPCap",L);
								else
									return 0;
								end
							elseif SN > "TACMITMPRATPCAPR" then
								if SN > "TPENARMOUR" then
									if SN == "TPENBPE" then
										return CalcStat("TpenChoice",N)*CalcStat("RatDefenceT",L);
									else
										return 0;
									end
								elseif SN == "TPENARMOUR" then
									return CalcStat("TpenChoice",N)*CalcStat("PhyMitT",L,5/3);
								else
									return 0;
								end
							else
								return CalcStat("MitMediumPRatPCapR",L);
							end
						elseif SN > "TPENCHOICE" then
							if SN < "TRAITPROG" then
								if SN == "TPENRESIST" then
									return CalcStat("TpenChoice",N)*CalcStat("ResistT",L,2);
								else
									return 0;
								end
							elseif SN > "TRAITPROG" then
								if SN > "WARDENCDARMOURTYPE" then
									if SN == "WARDENCDCANBLOCK" then
										return 1;
									else
										return 0;
									end
								elseif SN == "WARDENCDARMOURTYPE" then
									return 2;
								else
									return 0;
								end
							else
								if L-DblCalcDev <= 105 then
									return LinFmod(1,CalcStat("StatProg",1,N),CalcStat("StatProg",105,N),1,105,L);
								else
									return CalcStat("StatProg",L,N);
								end
							end
						else
							return DataTableValue({0,-1,-2},L);
						end
					else
						return CalcStat("MitMediumPRatPC",L);
					end
				else
					return CalcStat("MitLightPRatPB",L);
				end
			else
				return CalcRatAB(CalcStat("TacDmgPRatPA",L),CalcStat("TacDmgPRatPB",L),CalcStat("TacDmgPRatPCapR",L),N);
			end
		else
			return CalcStat("MitMediumPBonus",L);
		end
	else
		return CalcStat("PartBPEPRatPC",L);
	end

end

-- Support functions for CalcStat. These consist of implementations of more complex calculation types, decode methods for parameter "C" and rounding/min/max/compare functions for floating point numbers.

-- ****************** Calculation Type support functions ******************

-- DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD
-- DataTableValue: Takes a value from an array table.

function DataTableValue(vDataArray, lIndex)

	if lIndex <= 1 then
		return vDataArray[1];
	elseif lIndex > #vDataArray then
		return vDataArray[#vDataArray];
	else
		return vDataArray[lIndex];
	end

end

-- EEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEE
-- ExpFmod: Exponential function based on percentage.
-- Common percentage values are around ~5.5% for between levels and ~20% jumps between level segments.

function ExpFmod(dVal, dLstart, dPlvl, dLvl)

	if dLvl-dLstart+1 <= DblCalcDev then
		return dVal;
	else
		return dVal*(1+dPlvl/100)^(dLvl-dLstart+1);
	end

end

-- PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP
-- CalcPercAB: Calculates the percentage out of a rating based on the AB formula.

function CalcPercAB(dA, dB, dPCap, dR)

	if dR <= DblCalcDev then
		return 0;
	else
		local dResult = dA/(1+dB/dR);
		if dResult >= dPCap-DblCalcDev then
			return dPCap;
		else
			return dResult;
		end
	end

end

-- RRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRR
-- CalcRatAB: Calculates the rating out of a percentage based on the AB formula.

function CalcRatAB(dA, dB, dCapR, dP)

	if dP <= DblCalcDev then
		return 0;
	else
		local dResult = dB/(dA/dP-1);
		if dResult >= dCapR-DblCalcDev then
			return dCapR;
		else
			return dResult;
		end
	end

end

-- TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT
-- LinFmod: Linear line function between 2 points with some optional modifications.
-- Connects point (dLstart,dVal*dFstart) with (dLend,dVal*dFend).
-- Usually used with dVal=1 and dFstart/dFend containing unrelated points or dVal=# and dFstart/dFend containing multiplier factors.
-- Modification for in-between points on the line: rounding.

function LinFmod(dVal, dFstart, dFend, dLstart, dLend, dLvl, vDec)

	if dLstart-DblCalcDev <= dLvl and dLvl <= dLstart+DblCalcDev then
		return dVal*dFstart;
	elseif dLend-DblCalcDev <= dLvl and dLvl <= dLend+DblCalcDev then
		return dVal*dFend;
	elseif vDec == nil then
		return dVal*(dFstart*(dLend-dLvl)+(dLvl-dLstart)*dFend)/(dLend-dLstart);
	elseif -DblCalcDev <= vDec and vDec <= DblCalcDevl then
		return math.floor(dVal*(dFstart*(dLend-dLvl)+(dLvl-dLstart)*dFend)/(dLend-dLstart)+0.5+DblCalcDev);
	else
		return math.floor((dVal*(dFstart*(dLend-dLvl)+(dLvl-dLstart)*dFend)/(dLend-dLstart))*10^vDec+0.5+DblCalcDev)/10^vDec;
	end

end

-- ****************** Parameter "C" decode support functions ******************

-- ArmCodeIndex: returns a specified index from an Armour Code.
-- sACode string:
-- 1st position: H=heavy, M=medium, L=light
-- 2nd position: H=head, S=shoulders, CL=cloak/back, C=chest, G=gloves, L=leggings, B=boots, Sh=shield
-- 3rd position: W=white/common, Y=yellow/uncommon, P=purple/rare, T=teal/blue/incomparable, G=gold/legendary/epic
-- Note: no such thing exists as a heavy, medium or light cloak, so no H/M/L in cloak codes (cloaks go automatically in the M class since U23, although historically this was L)

function ArmCodeIndex(sACode, iI)

	local sArmCode = string.upper(string.match(sACode,"(%a+)"));

	local sArmClass = string.sub(sArmCode,1,1);
	local sArmType = string.sub(sArmCode,2,2);
	local sArmCol = string.sub(sArmCode,3,3);
	if sArmType == "S" and sArmCol == "H" then
		sArmType = "SH";
		sArmCol = string.sub(sArmCode,4,4);
	elseif sArmClass == "C" and sArmType == "L" then
		sArmClass = "M";
		sArmType = "CL";
	else
		sArmType = " "..sArmType;
	end
	
	if iI == 1 then
		return string.find("HML",sArmClass);
	elseif iI == 2 then
		return (string.find(" H SCL C G L BSH",sArmType)+1)/2;
	elseif iI == 3 then
		return string.find("WYPTG",sArmCol);
	end
	
	return 0;
	
end

-- RomanRankDecode: converts a string with a Roman number in characters, to an integer number.
-- used for Legendary Item Title calculation.

local RomanCharsToValues = {["M"]=1000,["CM"]=900,["D"]=500,["CD"]=400,["C"]=100,["XC"]=90,["L"]=50,["XL"]=40,["X"]=10,["IX"]=9,["V"]=5,["IV"]=4,["I"]=1};

function RomanRankDecode(sNumber)

	if sNumber ~= nil and sNumber ~= "" then
		for sRomanRankChar, iRomanRankValue in pairs(RomanCharsToValues) do
			if string.sub(string.upper(sNumber),1,string.len(sRomanRankChar)) == sRomanRankChar then
				return iRomanRankValue+RomanRankDecode(string.sub(sNumber,string.len(sRomanRankChar)+1));
			end
		end
	end
	
	return 0;
	
end

-- ****************** Misc. floating point support functions ******************

-- Misc. functions for floating point rounding.
-- 2nd parameter is number of decimals.

function RoundDbl(dNum, vDec)

	if vDec == nil or (-DblCalcDev <= vDec and vDec <= DblCalcDev) then
		return math.floor(dNum+0.5+DblCalcDev);
	else
		return math.floor(dNum*10^vDec+0.5+DblCalcDev)/10^vDec;
	end
	
end

function FloorDbl(dNum, vDec)

	if vDec == nil or (-DblCalcDev <= vDec and vDec <= DblCalcDev) then
		return math.floor(dNum+DblCalcDev);
	else
		return math.floor(dNum*10^vDec+DblCalcDev)/10^vDec;
	end

end
